

function sp = CalSP(ptn, w)
% calculate stable pattern

[ptn_h ptn_w] = size(ptn);

ptn_t = [ptn; -ones(1,ptn_w)];% pattern with theta dimension
sp1 = 0;    
tmp = w*ptn_t;

result = zeros(size(tmp));
result(find(tmp~=0)) = sign(tmp(find(tmp~=0)));      % those values which are nonzero will be assigned values according to their sign.
result(find(tmp==0)) = sign(ptn(find(tmp==0)));      % according to previous status if it has zero value.
result(find(abs(tmp)<eps)) = sign(ptn(find(abs(tmp)<eps)));      % according to previous status if it has zero value.

sp1 = sp1 + sum(~any(result-ptn));         %how many columns of result equals to columns of ptn.

sp = sp1;

